/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_PROXY_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_PROXY_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioProxyBase.hpp>

#include "v1/commonapi/telux/cv2x/Cv2xRadioTypesProxy.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif


#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

template <typename ... _AttributeExtensions>
class Cv2xRadioProxy
    : virtual public Cv2xRadio,
      virtual public Cv2xRadioProxyBase,
      public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesProxy<_AttributeExtensions...>,
      virtual public _AttributeExtensions... {
public:
    Cv2xRadioProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~Cv2xRadioProxy();

    typedef Cv2xRadio InterfaceType;

    inline static const char* getInterface() {
        return(Cv2xRadio::getInterface());
    }

    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

    virtual std::future<void> getCompletionFuture();

    /**
     * Calls createRxSubscription with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void createRxSubscription(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint16_t _port, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_subscriptionId, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls createRxSubscription with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> createRxSubscriptionAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint16_t &_port, const std::vector< uint32_t > &_idList, CreateRxSubscriptionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls getServiceStatus with synchronous semantics.
     *
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void getServiceStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus &_status, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls getServiceStatus with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> getServiceStatusAsync(GetServiceStatusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls enableRxMetaDataReport with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void enableRxMetaDataReport(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, bool _enable, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls enableRxMetaDataReport with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> enableRxMetaDataReportAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const bool &_enable, const std::vector< uint32_t > &_idList, EnableRxMetaDataReportAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls createTxSpsFlow with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void createTxSpsFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, uint16_t _spsSrcPort, bool _eventSrcPortValid, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txSpsFlowId, uint32_t &_txEventFlowId, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_spsError, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_eventError, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls createTxSpsFlow with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> createTxSpsFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const uint16_t &_spsSrcPort, const bool &_eventSrcPortValid, const uint16_t &_eventSrcPort, CreateTxSpsFlowAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls createTxEventFlow with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void createTxEventFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipTyp, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _flowInfo, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txEventFlowId, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls createTxEventFlow with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> createTxEventFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipTyp, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_flowInfo, const uint16_t &_eventSrcPort, CreateTxEventFlowAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls closeRxSubscription with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void closeRxSubscription(uint32_t _subscriptionId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls closeRxSubscription with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> closeRxSubscriptionAsync(const uint32_t &_subscriptionId, CloseRxSubscriptionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls closeTxFlow with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void closeTxFlow(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls closeTxFlow with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> closeTxFlowAsync(const uint32_t &_txFlowId, CloseTxFlowAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls changeSpsFlowInfo with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void changeSpsFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls changeSpsFlowInfo with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> changeSpsFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, ChangeSpsFlowInfoAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls requestSpsFlowInfo with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void requestSpsFlowInfo(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls requestSpsFlowInfo with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> requestSpsFlowInfoAsync(const uint32_t &_txFlowId, RequestSpsFlowInfoAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls changeEventFlowInfo with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void changeEventFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _eventInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls changeEventFlowInfo with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> changeEventFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_eventInfo, ChangeEventFlowInfoAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls requestCapability with synchronous semantics.
     *
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void requestCapability(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls requestCapability with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> requestCapabilityAsync(RequestCapabilityAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Returns the wrapper class that provides access to the broadcast currentCv2xStatus.
     */
    virtual CurrentCv2xStatusEvent& getCurrentCv2xStatusEvent() {
        return delegate_->getCurrentCv2xStatusEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast currentCv2xStatusEx.
     */
    virtual CurrentCv2xStatusExEvent& getCurrentCv2xStatusExEvent() {
        return delegate_->getCurrentCv2xStatusExEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast currentL2Addr.
     */
    virtual CurrentL2AddrEvent& getCurrentL2AddrEvent() {
        return delegate_->getCurrentL2AddrEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast currentSpsOffset.
     */
    virtual CurrentSpsOffsetEvent& getCurrentSpsOffsetEvent() {
        return delegate_->getCurrentSpsOffsetEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast currentCapabilities.
     */
    virtual CurrentCapabilitiesEvent& getCurrentCapabilitiesEvent() {
        return delegate_->getCurrentCapabilitiesEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast macAddrClone.
     */
    virtual MacAddrCloneEvent& getMacAddrCloneEvent() {
        return delegate_->getMacAddrCloneEvent();
    }



 private:
    std::shared_ptr< Cv2xRadioProxyBase> delegate_;
};

typedef Cv2xRadioProxy<> Cv2xRadioProxyDefault;


//
// Cv2xRadioProxy Implementation
//
template <typename ... _AttributeExtensions>
Cv2xRadioProxy<_AttributeExtensions...>::Cv2xRadioProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypesProxy<_AttributeExtensions...>(delegate),
        _AttributeExtensions(*(std::dynamic_pointer_cast< Cv2xRadioProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast< Cv2xRadioProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
Cv2xRadioProxy<_AttributeExtensions...>::~Cv2xRadioProxy() {
}

template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::createRxSubscription(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint16_t _port, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_subscriptionId, const CommonAPI::CallInfo *_info) {
    if (!_ipType.validate()) {
        _internalCallStatus = CommonAPI::CallStatus::INVALID_VALUE;
        return;
    }
    delegate_->createRxSubscription(_ipType, _port, _idList, _internalCallStatus, _error, _subscriptionId, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::createRxSubscriptionAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint16_t &_port, const std::vector< uint32_t > &_idList, CreateRxSubscriptionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    if (!_ipType.validate()) {
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        uint32_t subscriptionId = 0ul;
        _callback(CommonAPI::CallStatus::INVALID_VALUE, error, subscriptionId);
        std::promise<CommonAPI::CallStatus> promise;
        promise.set_value(CommonAPI::CallStatus::INVALID_VALUE);
        return promise.get_future();
    }
    return delegate_->createRxSubscriptionAsync(_ipType, _port, _idList, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::getServiceStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus &_status, const CommonAPI::CallInfo *_info) {
    delegate_->getServiceStatus(_internalCallStatus, _error, _status, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::getServiceStatusAsync(GetServiceStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->getServiceStatusAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::enableRxMetaDataReport(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, bool _enable, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info) {
    if (!_ipType.validate()) {
        _internalCallStatus = CommonAPI::CallStatus::INVALID_VALUE;
        return;
    }
    delegate_->enableRxMetaDataReport(_ipType, _enable, _idList, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::enableRxMetaDataReportAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const bool &_enable, const std::vector< uint32_t > &_idList, EnableRxMetaDataReportAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    if (!_ipType.validate()) {
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        _callback(CommonAPI::CallStatus::INVALID_VALUE, error);
        std::promise<CommonAPI::CallStatus> promise;
        promise.set_value(CommonAPI::CallStatus::INVALID_VALUE);
        return promise.get_future();
    }
    return delegate_->enableRxMetaDataReportAsync(_ipType, _enable, _idList, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::createTxSpsFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, uint16_t _spsSrcPort, bool _eventSrcPortValid, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txSpsFlowId, uint32_t &_txEventFlowId, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_spsError, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_eventError, const CommonAPI::CallInfo *_info) {
    if (!_ipType.validate()) {
        _internalCallStatus = CommonAPI::CallStatus::INVALID_VALUE;
        return;
    }
    delegate_->createTxSpsFlow(_ipType, _serviceId, _spsInfo, _spsSrcPort, _eventSrcPortValid, _eventSrcPort, _internalCallStatus, _error, _txSpsFlowId, _txEventFlowId, _spsError, _eventError, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::createTxSpsFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const uint16_t &_spsSrcPort, const bool &_eventSrcPortValid, const uint16_t &_eventSrcPort, CreateTxSpsFlowAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    if (!_ipType.validate()) {
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        uint32_t txSpsFlowId = 0ul;
        uint32_t txEventFlowId = 0ul;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode spsError = ::v1::commonapi::telux::common::CommonDefines::ErrorCode::SUCCESS;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode eventError = ::v1::commonapi::telux::common::CommonDefines::ErrorCode::SUCCESS;
        _callback(CommonAPI::CallStatus::INVALID_VALUE, error, txSpsFlowId, txEventFlowId, spsError, eventError);
        std::promise<CommonAPI::CallStatus> promise;
        promise.set_value(CommonAPI::CallStatus::INVALID_VALUE);
        return promise.get_future();
    }
    return delegate_->createTxSpsFlowAsync(_ipType, _serviceId, _spsInfo, _spsSrcPort, _eventSrcPortValid, _eventSrcPort, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::createTxEventFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipTyp, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _flowInfo, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txEventFlowId, const CommonAPI::CallInfo *_info) {
    if (!_ipTyp.validate()) {
        _internalCallStatus = CommonAPI::CallStatus::INVALID_VALUE;
        return;
    }
    delegate_->createTxEventFlow(_ipTyp, _serviceId, _flowInfo, _eventSrcPort, _internalCallStatus, _error, _txEventFlowId, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::createTxEventFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipTyp, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_flowInfo, const uint16_t &_eventSrcPort, CreateTxEventFlowAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    if (!_ipTyp.validate()) {
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        uint32_t txEventFlowId = 0ul;
        _callback(CommonAPI::CallStatus::INVALID_VALUE, error, txEventFlowId);
        std::promise<CommonAPI::CallStatus> promise;
        promise.set_value(CommonAPI::CallStatus::INVALID_VALUE);
        return promise.get_future();
    }
    return delegate_->createTxEventFlowAsync(_ipTyp, _serviceId, _flowInfo, _eventSrcPort, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::closeRxSubscription(uint32_t _subscriptionId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info) {
    delegate_->closeRxSubscription(_subscriptionId, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::closeRxSubscriptionAsync(const uint32_t &_subscriptionId, CloseRxSubscriptionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->closeRxSubscriptionAsync(_subscriptionId, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::closeTxFlow(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info) {
    delegate_->closeTxFlow(_txFlowId, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::closeTxFlowAsync(const uint32_t &_txFlowId, CloseTxFlowAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->closeTxFlowAsync(_txFlowId, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::changeSpsFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info) {
    delegate_->changeSpsFlowInfo(_txFlowId, _spsInfo, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::changeSpsFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, ChangeSpsFlowInfoAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->changeSpsFlowInfoAsync(_txFlowId, _spsInfo, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::requestSpsFlowInfo(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const CommonAPI::CallInfo *_info) {
    delegate_->requestSpsFlowInfo(_txFlowId, _internalCallStatus, _error, _spsInfo, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::requestSpsFlowInfoAsync(const uint32_t &_txFlowId, RequestSpsFlowInfoAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->requestSpsFlowInfoAsync(_txFlowId, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::changeEventFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _eventInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info) {
    delegate_->changeEventFlowInfo(_txFlowId, _eventInfo, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::changeEventFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_eventInfo, ChangeEventFlowInfoAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->changeEventFlowInfoAsync(_txFlowId, _eventInfo, _callback, _info);
}
template <typename ... _AttributeExtensions>
void Cv2xRadioProxy<_AttributeExtensions...>::requestCapability(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities, const CommonAPI::CallInfo *_info) {
    delegate_->requestCapability(_internalCallStatus, _error, _capabilities, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> Cv2xRadioProxy<_AttributeExtensions...>::requestCapabilityAsync(RequestCapabilityAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->requestCapabilityAsync(_callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &Cv2xRadioProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool Cv2xRadioProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool Cv2xRadioProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& Cv2xRadioProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& Cv2xRadioProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


template <typename ... _AttributeExtensions>
std::future<void> Cv2xRadioProxy<_AttributeExtensions...>::getCompletionFuture() {
    return delegate_->getCompletionFuture();
}

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1



// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_PROXY_HPP_
